import * as React from 'react';
import { Subject } from 'rxjs';
import { GlamorValue, t } from '../../common';
export declare type FormulaInputMode = 'spreadsheet';
export interface IFormulaInputProps {
    value?: string;
    mode?: FormulaInputMode;
    fontSize?: number;
    multiline?: boolean;
    allowTab?: boolean;
    focusOnLoad?: boolean;
    selectOnLoad?: boolean;
    maxLength?: number;
    height?: number;
    events$?: Subject<t.FormulaInputEvent>;
    style?: GlamorValue;
}
export interface IFormulaInputState {
    isLoaded?: boolean;
}
export declare class FormulaInput extends React.PureComponent<IFormulaInputProps, IFormulaInputState> {
    state: IFormulaInputState;
    private unmounted$;
    private state$;
    private editor;
    private editorRef;
    private readonly _events$;
    readonly events$: import("rxjs").Observable<t.FormulaInputEvent>;
    private readonly modifierKeys;
    componentWillMount(): void;
    componentDidMount(): void;
    private init;
    componentWillUnmount(): void;
    readonly isFocused: boolean;
    private readonly height;
    private readonly className;
    private readonly fontSize;
    redraw(): this;
    focus(): this;
    selectAll(): this;
    cursorToStart(): this;
    cursorToEnd(): this;
    private setGlobalStyles;
    render(): JSX.Element;
    private fire;
    private focusHandler;
    private handleBeforeChange;
}
